# Contributing

Thanks for being interested in improving Enumpath! We welcome [all kinds of contributions][how-to-contribute]. There are a couple of things you should know before contributing to this repository:

1. Unless your changes are related to an existing issue, please first open a new issue to discuss the changes you wish to make.
2. Please note we have a [code of conduct](#code-of-conduct), please follow it in all your interactions with the project.
3. Code quality is important to us! Please be prepared to to address all code quality comments, whether from a CI tool like Hound or directly from our maintainers, before we can accept your changes.

## Pull Request Process

1. Fork the repo.
2. Make sure the tests pass before you begin working.
3. Make your changes, with new passing tests. Follow the [Ruby Style Guide][ruby-style-guide].
4. Push to your fork using a [good commit message][a-note-about-git-commit-messages].
5. Submit a [good pull request][how-to-write-the-perfect-pull-request] from your fork to our project.
6. Others will give constructive feedback. This is a time for discussion and improvements, and making the necessary changes will be required before we can merge the contribution.

## Code of Conduct

### Our Pledge

In the interest of fostering an open and welcoming environment, we as
contributors and maintainers pledge to making participation in our project and
our community a harassment-free experience for everyone, regardless of age, body
size, disability, ethnicity, sex characteristics, gender identity and expression,
level of experience, education, socio-economic status, nationality, personal
appearance, race, religion, or sexual identity and orientation.

### Our Standards

Examples of behavior that contributes to creating a positive environment
include:

* Using welcoming and inclusive language
* Being respectful of differing viewpoints and experiences
* Gracefully accepting constructive criticism
* Focusing on what is best for the community
* Showing empathy towards other community members

Examples of unacceptable behavior by participants include:

* The use of sexualized language or imagery and unwelcome sexual attention or
  advances
* Trolling, insulting/derogatory comments, and personal or political attacks
* Public or private harassment
* Publishing others' private information, such as a physical or electronic
  address, without explicit permission
* Other conduct which could reasonably be considered inappropriate in a
  professional setting

### Our Responsibilities

Project maintainers are responsible for clarifying the standards of acceptable
behavior and are expected to take appropriate and fair corrective action in
response to any instances of unacceptable behavior.

Project maintainers have the right and responsibility to remove, edit, or
reject comments, commits, code, wiki edits, issues, and other contributions
that are not aligned to this Code of Conduct, or to ban temporarily or
permanently any contributor for other behaviors that they deem inappropriate,
threatening, offensive, or harmful.

### Scope

This Code of Conduct applies both within project spaces and in public spaces
when an individual is representing the project or its community. Examples of
representing a project or community include using an official project e-mail
address, posting via an official social media account, or acting as an appointed
representative at an online or offline event. Representation of a project may be
further defined and clarified by project maintainers.

### Enforcement

Instances of abusive, harassing, or otherwise unacceptable behavior may be
reported by contacting the project team at [chrisbloom7/enumpath][enumpath-gh]. All
complaints will be reviewed and investigated and will result in a response that
is deemed necessary and appropriate to the circumstances. The project team is
obligated to maintain confidentiality with regard to the reporter of an incident.
Further details of specific enforcement policies may be posted separately.

Project maintainers who do not follow or enforce the Code of Conduct in good
faith may face temporary or permanent repercussions as determined by other
members of the project's leadership.

### Attribution

This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4,
available at https://www.contributor-covenant.org/version/1/4/code-of-conduct.html

[a-note-about-git-commit-messages]: https://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
[enumpath-gh]: https://github.com/chrisbloom7/enumpath
[homepage]: https://www.contributor-covenant.org
[how-to-contribute]: https://opensource.guide/how-to-contribute/
[how-to-write-the-perfect-pull-request]: https://blog.github.com/2015-01-21-how-to-write-the-perfect-pull-request/
[ruby-style-guide]: https://github.com/rubocop-hq/ruby-style-guide
[version]: http://contributor-covenant.org/version/1/4/
